+function ($) {
"use strict";
    
var calCtrl = {
	
    $element : null, 
    $header : null, 
    $items : null, 

//    responsive : false,
    isEditor : false,
    
    year : 0,	
    month : 0,	
    daysNum : 0,	
    
//    _proxiedResize : null,

    init : function($element){
        this.$element = $element;
        this.$header = this.$element.find('.header');
        this.$items = this.$element.find('.item');

        this.isEditor = this.$element.hasClass('editor');
        
        this.year = parseInt(this.$element.data('year'));
        this.month = parseInt(this.$element.data('month'));
        this.daysNum = this.$header.find('.day').length;

        this.initEditor();
        this.initPopovers();

//        this._proxiedResize = $.proxy(this.windowResize, this);
        
//        mainCtrl.on('resize', this._proxiedResize);
    },
	
	
    initEditor : function(){
        if (!this.isEditor)
            return;

        var self = this;
        
        this.$element.on('click', '.day .events-list', function(){
//            console.log('clicked');
            if (selectionCtrl.justStoppedSelection()) //prevent opening modal if selecting one cell
                return;
            
            
            var $eventsListEl = $(this);			
            var $day = $eventsListEl.closest('.day');
            var itemId = $eventsListEl.closest('.item').data('item-id');

            var dayNum = $day.index() + 1;

            selectionCtrl.clearSelection();

            var editOptions = {
                days : [{year: self.year, month: self.month, day: dayNum}],
                itemId: itemId,
                dateString : self.$header.find('.day').eq(dayNum - 1).data('date-string')
            };
            
            //needed on mobile
            self.hideAllPopovers();

            modalEventsEditCtrl.open(
                'edit',
                function(events){

                   var data = {
                       year : editOptions.days[0].year,
                       month : editOptions.days[0].month,
                       day : editOptions.days[0].day,
                       item_id : itemId,
                       events : events
                   };

                   serviceCtrl.saveEventsForDay(data, function(result){
                       mainCtrl.showNotify(result[0]);

                       $eventsListEl.replaceWith(result[1]);
                   });

               },
               null, //callback cancel
               editOptions
            );

        });
    },	

	
    initPopovers : function(){

        var self = this;

        //init events popovers
        this.$element.popover({
            selector: '.day .events-list:not(.num-0)', //allows dynamically change this divs
            trigger: 'hover',
            html: true,
            sanitize: false,
            content: function(el){
                var $eventsDiv = $(this);
                return $eventsDiv.get(0).outerHTML;
            },	
            placement: function(){
                
                return mainCtrl.win.safeWidth <= 650 ? 'auto' : 'right';
            },
            template: '<div class="popover cal-popover events" role="tooltip"><div class="arrow"></div><div class="popover-body"></div></div>',
        });	

        var delayTime = 300;

        //init item name popovers
        this.$element.find('.item .name-wrap').each(function(){
            var $el = $(this);

            if (!$el.parent().find('.details').length){
                return;
            }

            $el.popover({
                trigger: 'manual',
                html: true,
                sanitize: false,
                content: function(el){
                        var $el = $(this).parent();
                        return $el.find('.details').get(0).outerHTML;
                },	
                placement: 'bottom',
                title: function(el){
                        var $el = $(this).parent();
                        // console.log($el.find('.name').text());
                        return $el.find('.name').text();
                },
                template: '<div class="popover cal-popover name" role="tooltip"><div class="arrow"></div><h3 class="popover-header"></h3><div class="popover-body"></div></div>',
            })
            .on('inserted.bs.popover', function (e) {
                var $opener = $(e.target);
                var bsData = $opener.data()['bs.popover'];
                var $popover = $(bsData.tip);

                //move popover to right
                bsData.config.offset = Math.round(($popover.outerWidth() / 2) - ($opener.outerWidth()  / 2)) - 5 + 'px';
                //used to prevent close popup too soon
                $popover
                    .on('mouseenter', function(){
                        var $popover = $(this);
                        var $opener = $('[aria-describedby="'+ $popover.attr('id') +'"]');

                        //stop timer that will hide popover
                        clearTimeout($opener.data('hideTimeout'));
                    })
                    .on('mouseleave', function(){
                        var $popover = $(this);
                        var $opener = $('[aria-describedby="'+ $popover.attr('id') +'"]');

                        var timeoutId = setTimeout(function () {
                                $opener.popover('hide');
                        }, delayTime / 2 );

                        $opener.data('hideTimeout', timeoutId);
                    });
            })
            .on('hidden.bs.popover', function (e) {
                var $opener = $(e.target);
                var bsData = $opener.data()['bs.popover'];
                var $popover = $(bsData.tip);

                $popover.off('mouseenter mouseleave')
            });
        });

        //algorithm allowing go mouse over popovers and not to hide popover
        this.$element.find('.item .name-wrap') //only on items that have needed popovers
            .on('mouseenter', function (){
//                console.log('mouseenter enter opener');
                var $opener = $(this);

                //donthave popover enabled
                if (!$opener.data('bs.popover'))
                    return;

                // console.log($opener.data('bs.popover').tip)
                // console.log($opener.data('bs.popover')._popper.state.isDestroyed);
                //if mouse move from popover to element itself do not hide and reshow popover
                if ($opener.data('bs.popover').tip && $($opener.data('bs.popover').tip).hasClass('show') ){

//                        console.log('stop');
                        //stop timer that will hide popover
                        clearTimeout($opener.data('hideTimeout'));
                        return;
                }	

                //imidiatelly hide all popovers do not wait 300ms
                self.hideAllPopovers();

                $opener.popover('show');
            })
            .on('mouseleave', function (){
                var $opener = $(this);

                   //donthave popover enabled
                if (!$opener.data('bs.popover'))
                    return;

                var timeoutId = setTimeout(function () {
                        $opener.popover('hide');
                }, delayTime);

                $opener.data('hideTimeout', timeoutId);
            });
	},
	
    hideAllPopovers : function(){
        $('.cal-popover').each(function(){
            var $opener = $($(this).data('bs.popover').element);
            clearTimeout($opener.data('hideTimeout')); //if exists
            $opener.popover('hide');
        });	
    },
    
    destroy : function(){
       
    }
    
};
	
    window.calCtrl = calCtrl;
	
}($);