+function ($) {
    "use strict";
    
var pageBrowse = {

    init : function(){
        pageCalBase.init.apply(this, arguments); //call super
        
        this.$typeSelect = this.$page.find('.filter select[data-type-filter]');
        this.$fieldSelects = this.$page.find('.filter select[data-field-filter]');
        
        this.$fieldsGroup = this.$page.find('.form-group[data-field-filters]');
        
        var self = this;
        
        
        
 
        //initiatlize all selects
        this.$typeSelect.add(this.$fieldSelects).each(function(){
            var $select = $(this);

            $select.get(0).selectedIndex  = 0; //on history back button reset
            
            $select
                .selectpicker({
                    style : 'custom-select custom-select-sm selectpicker',
                    liveSearch : $select.find('option').length >= 10 ? true : false,
                    noneResultsText: $select.data('no-results'),
                    noneSelectedText: $select.attr('placeholder')
                });
                
            if ($select.is('[data-field-filter]')){
//                console.log('a');
                $select.selectpicker('val', ''); //reset to show placeholder
            }
        });
        
        this.$typeSelect.change(function(event){
            var val = self.$typeSelect.selectpicker('val');
            
            self.$fieldSelects.selectpicker('hide');
//            console.log(val);

            var l = self.$fieldSelects.filter('[data-item-type-id="'+ val +'"]').selectpicker('show').length;
            
            self.$fieldSelects.selectpicker('val', ''); //reset
//            console.log(l);
            self.$fieldsGroup.toggleClass('d-none', l == 0 ? true : false);
            
            self.windowResize(); //updates flex wrap
            
            
            if (event.originalEvent) //only when realy clicked
                self.filter(val);
            
        });
        this.$typeSelect.triggerHandler('change');
        
        
        this.$fieldSelects.change(function(){
            var $select = $(this);
            
            var val = $select.selectpicker('val');
            var itemTypeId = $select.data('itemTypeId');
            var fieldTypeId = $select.data('fieldTypeId');

            self.$fieldSelects.not($select).selectpicker('val', ''); //reset other fields
            
            self.filter(itemTypeId, fieldTypeId, val);
        });
        
        
        if (YourCalendar.item_to_show){
 
            setTimeout(function(){
                var $items = self.$page.find('.cali .item[data-item-id="'+YourCalendar.item_to_show +'"]');

                var c = function(){
                    $items.addClass('blink');
                };
            
                //if not in viewport
                if (!mainCtrl.inViewport($items.eq(0))){
                    mainCtrl.scrollToEl($items.eq(0), 100, c);
                }
                else{
                    c();
                }
            }, 500); //delay
        }

    },
    
    filter : function(itemTypeId, fieldTypeId, value){
        itemTypeId = itemTypeId ? itemTypeId : 0;
        fieldTypeId = fieldTypeId ? fieldTypeId : 0;
        value = value ? value : '';
        
        var $cal = this.$page.find('.cali').eq(0);
        
        var params = {
            year : $cal.data('year'),
            month : $cal.data('month'),
            item_type_id : itemTypeId,
            field_type_id : fieldTypeId,
            value : value
        };
        
        var self = this;
        
        this.destroyCals();
        serviceCtrl.filter(params, function(result){
            self.$page.find('.calendars').html(result);
            self.initCals();
            self.windowResize(); //updates itself
        });
        
        
        
    },
    windowResize : function(){
        pageCalBase.windowResize.apply(this, arguments); //call super
         
//        if (this.$fieldsGroup)
            mainCtrl.flexWrappedHelper(this.$fieldsGroup);
    }
    


    
}


window.pageBrowse = $.extend(true, {}, pageCalBase, pageBrowse); //must be deep copy;
	
}($);