+function ($) {
"use strict";

var pageCalBase = {

    calInstances : [],

    init: function () {
        this.$page = $('.page');
        
        var self = this;

        //redirects to specified month
        this.$page.find('button[data-select-date]').monthSelector();
        this.$page.find('button[data-select-date]').on('change', function (event, obj) {
            var path = self.$page.is('.page-browse') ? '' : 'edit/';
            
            var url = YourCalendar.siteUrl + path  + obj.year + '/' + obj.month;
            
            if (path == 'edit/'){
                var itemId = self.$page.data('item-id');
                
                if (itemId != 0)
                    url += '/' + itemId;
            }

            window.location.href = url;
        });

        //month buttons
        this.$page.find('button[data-year]').click(function(){
            var $btn =  $(this);
            var year = $btn.data('year');
            var month = $btn.data('month');

//            console.log(self.$page.find('.cali[data-year="'+ year  +'"][data-month="' + month+ '"]').length);
            mainCtrl.scrollToEl(self.$page.find('.cali[data-year="'+ year  +'"][data-month="' + month+ '"]'));
        });
        
        //before cal instances
        mainCtrl.on('resize', $.proxy(this.windowResize, this));
        

        this.initCals();

        pageBase.init.apply(this, arguments); //call super
    },

    windowResize: function () {
        mainCtrl.flexWrappedHelper(this.$page.find('.cal-navigation > .controls'));

        //if multiple month selector
        if (this.$page.find('.cal-navigation > .controls .month-controls').length){
            mainCtrl.flexWrappedHelper(this.$page.find('.cal-navigation > .controls .month-controls'));
        }

//        console.time('resize');
        var self = this;
        
        var $cals = this.$page.find('.cali');
        var $nameColumns = $cals.find('.name-column');
        
        $nameColumns.css('width', ''); //reset
        $cals.outerWidth(''); //reset
        //take calWidth if its smaller than 31 days with longest name fit than make all responsive
        var calWidth = $cals.eq(0).outerWidth();
        var responsive = calWidth < (1220  + 31);
        
        //make it after 
        $cals.toggleClass('responsive', responsive);
        
        var nameColWidth = 0;
        
        if (!responsive){
            $nameColumns.each(function(){
                nameColWidth = Math.ceil(Math.max(nameColWidth, $(this).outerWidth()));
            });
            $nameColumns.outerWidth(nameColWidth);
        }

        $cals.each(function(index){
            var $cal = $(this); 
            
            var daysInRow = Math.min(self.calInstances[index].daysNum, Math.floor(calWidth / 31));
            
            if (responsive){
                $cal.outerWidth(daysInRow * 31);
            }
            else{                
                $cal.outerWidth((daysInRow * 31) + nameColWidth);
            }
            
            //when we are in responsive view, add left border to days that wraped into another line
           $cal.find('.day.first-in-row').removeClass('first-in-row');

            if (responsive){
                $cal.find('.day:nth-child('+ daysInRow +'n+1)').addClass('first-in-row');
            }
        });
        
//        console.timeEnd('resize');
    },

    initCals: function () {
        var self = this;
        this.$page.find('.cali').each(function(){
            var $calEl = $(this);

            var calInstance = self.newCalInstance();
            calInstance.init($calEl);

            self.calInstances.push(calInstance);
        });
    },


    destroyCals: function () {
        $.each(this.calInstances, function( index, calInstance ) {
            calInstance.destroy();
        });

        this.calInstances = [];
    },

    newCalInstance: function () {
        return $.extend({}, window.calCtrl);
    }

};


window.pageCalBase = $.extend(true, {}, pageBase, pageCalBase); //must be deep copy;

}($);