+function ($) {
    "use strict";
    
var pageEditSelect = {

    init : function(){
        this.$page = $('.page-edit-select');
        this.$searchInput = this.$page.find('input[name="search"]');
        this.$typeFilterSelect =  this.$page.find('select[data-filter]');
        
        this.debouncedFilter = mainCtrl.debounce($.proxy(this.filter, this), 200);

        this._findVars();
        
        var self = this;
	
        this.$typeFilterSelect.on('change', function(){
            self.$searchInput.val(''); //reset
            self.filter();
        })
        .triggerHandler('change'); //used when back button
        
        this.$searchInput.on('input', this.debouncedFilter);


        if (!mainCtrl.touch){
            setTimeout(function(){
                self.$searchInput.focus();

            }, 200);
        }

        pageBase.init.apply(this, arguments); //call super
    },
    
    
    filter : function(){
        var text = this.$searchInput.val().trim().toLowerCase(),
            type = this.$typeFilterSelect.val();
    
        var noFilter = !text && type == 'all';

        this.$itemList.toggleClass('filtered', !noFilter ? false : true);

        if (noFilter){
            this.$page.find('span[data-count]').text(this.$items.length);
            this.$items.appendTo(this.$itemList);
            return;
        }

        this.$items.remove();
        
        var $filtered =  this.$items;
        
        if (type != 'all'){
            $filtered = this.$items.filter('[data-type-id="'+ type +'"]');
        }

        if (text){
            $filtered = $filtered.find('a span').filter(function( index ) {
                return this.innerText.toLowerCase().search(text) !== -1;
            })
            .closest('.item');
        }

        $filtered.appendTo(this.$itemList);
        this.$page.find('span[data-count]').text($filtered.length);
    },
    
    _findVars : function(){
        this.$itemList = this.$page.find('.item-list .list');
        this.$items = this.$itemList.find('.item');
    }
    
    
}


window.pageEditSelect = $.extend(true, {}, pageBase, pageEditSelect); //must be deep copy;
	
}($);