+function($){
"use strict";

var pageFormBase = { 
    
    serviceMethod : null,
    formData : null,
    validator : null,
    
    redirectAfterSave : null,
    
    init : function(){     
        this.$saveButton = this.$page.find('button[data-save]');
        this.$saveBackButton = this.$page.find('button[data-save-redirect]');
        this.$form = this.$page.find('form');
        
        this.savingNew = false; //is saving new than we have to redirect after saving int editiong mode
 
        var self = this;

        this.fillForm();
        
        this.$form.submit(function(event){
            event.preventDefault();
            
            var isValid = formValidator.validateForm(self.$form);
            var additionalCheckRes = self.additionalFormCheck();
            
            if (!isValid){
                mainCtrl.$html.add(mainCtrl.$body).animate({scrollTop: 0}); //scroll to top to see alert message
                return;
            }
            
            if ( !additionalCheckRes )
                return;
            
            
            //must be after proper validation, that may remove messages of wrong fields
            if (!formValidator.isFormDirty(self.$form)){ //no changes made
                mainCtrl.showNotify(YourCalendar.lang.no_changes);
                return;
            }
            
           
            var formData = self.serializeForm();

            //call service method defined in parent object with proper this (serviceCtrl)
            serviceCtrl[self.serviceMethod]( //save settings to server
                formData,
                function(result){
                    self.saveSuccessCallback(result[0], result[1]);
                }
            );
                        
        });
        
        //make 
        this.$saveButton.click(function(){
            self.redirectAfterSave = null; //reset, might be clicked save with back than validation fails
            self.$form.submit();
        });
        
        this.$saveBackButton.click(function(){
            self.redirectAfterSave = true; //$(this).data('saveRedirect');
            self.$form.submit();
        });
        
        mainCtrl.$window.on('beforeunload', function() {
            if (formValidator.isFormDirty(self.$form)){
                return YourCalendar.lang.unsaved;
            }
        });
    },
    
    saveSuccessCallback : function(message, data){
        if (this.savingNew && !this.redirectAfterSave) {
            window.history.replaceState(null, '', YourCalendar.siteUrl + YourCalendar.pagePath + '/' + data.id);
            formValidator.cleanFormDirty(this.$form);
            mainCtrl.pendingMessage(message);
            location.reload();
            return;
        }
        
        
        if (this.redirectAfterSave){ 
            formValidator.cleanFormDirty(this.$form);
            mainCtrl.historyBack(message); //back
            return;
        }        
        
        mainCtrl.showNotify(message);
        this.formData = data;
        this.fillForm();
    },
    
    fillForm : function(){
        formValidator.resetForm(this.$form); //we must reset, if subcontroller sets some data in fill form
        formValidator.deserializeForm(this.$form, this.formData); 
        
        formValidator.cleanFormDirty(this.$form);
    },
    
    
    additionalFormCheck : function(){
        return true;
    },
    
    //used when serailizing form before sending ajax request
    serializeForm : function(){
        
        var serialized = formValidator.serializeForm(this.$form);
        //check are we saving new or editing
        if (serialized.id == '0') {
            this.savingNew = true;
        }
        
       return serialized;
    }
 
};

window.pageFormBase = $.extend(true, {}, pageFormBase); //must be deep copy

}($);