+function ($) {
    "use strict";

    var pageItemEdit = {

        init: function () {
            this.$page = $('.page-item-edit');

            this.serviceMethod = 'saveItem';
            this.formData = YourCalendar.item;
            this.$fields = this.$page.find('.fields');
            this.$fieldTemplate = this.$fields.find('.field').remove().removeClass('d-none');

            this.$page.find('.icon-selector').iconSelector({
                multi : false,
                showSectionHeaders : true
            });

            pageFormBase.init.apply(this, arguments); //call super
            pageBase.init.apply(this, arguments); //call super
        },
        

        //this is called twice on start and after saving
        fillForm: function () {
            pageFormBase.fillForm.apply(this, arguments); //call super

            var self = this;
            
            //destroy old uploaders
            self.$fields.find('.uploader').each(function(){
                $(this).uploader('destroy');
            });
            
            self.$fields.empty();//remove old fields
            
            this.formData.fields.forEach(function (field){
                self.$fields.append(self.prepareFieldTemplate(field, field.type.type));
            });
            
            
//            updates 
            this.$page.find('.icon-selector').iconSelector('update');
            
            formValidator.cleanFormDirty(this.$form);
        },

        serializeForm: function () {
            var serialized = pageFormBase.serializeForm.apply(this, arguments); //call super

            //search we have links, to fill text into array of serialized data
            serialized.fields = []; //create array from new when link is here it will fuck up result
            
            this.$page.find('.field').each(function(){
                var $field = $(this);
                var ser = formValidator.serializeForm( $field ).fields[0];
                
                ser.options = ser.options ? ser.options : []; //empty array, without string it will be removed;
                
//                console.log($field.data('options'));
                serialized.fields.push(ser);
            });
//            console.log(serialized.fields);
            // serialized.fields = serialized.fields.length ? serialized.fields : '[|empty-array|]';
            
            //send back type id
            serialized.type = {id: this.formData.type.id};


            return serialized;
        },

	//additional things to check when validating form
	prepareFieldTemplate : function(formData, type){
            var $field = this.$fieldTemplate.clone();

            //remove what is not used
            $field.find('[data-type][data-type!="' + type + '"]').remove();

            $field.find('span[data-label]').text(formData.type.label);
            //fill data
            formValidator.deserializeForm($field, formData);
            
//            $field.data('options', formData.options);
            $field.find('input[name="type[id]"]').val(formData.type.id);
            
            if (type == 'link' && formData.options)
            {
                $field.find('input[name="options[text]"]').val(formData.options.text);
            }


            // alert();
            var self = this;

            //add ids to inputs and for arguments to labels
            $field.find('input,select').each(function(){
                var $input = $(this);

                var randomId = 'a' + Math.floor(Math.random() * 9999);

                $input.attr('id', randomId);
                $input.siblings('label').attr('for', randomId);

                //if input has name if not skip
                if ($input.is('[name]')){
        //                    preare names of input fields
                    $input.attr('name', 'fields[]['+ $input.attr('name') + ']');
                }
            });

            if (type == 'image'){
                $field.find('.uploader').uploader({
                    action: 'field',
                    allowedExtensions: ['jpg'],
                    accept: '.jpg',
                    previewWidth : 150,
                });
            }

            return $field;
	},


    };

    window.pageItemEdit = $.extend(true, {}, pageBase, pageFormBase, pageItemEdit); //must be deep copy;

}($);