+function ($) {
    "use strict";
    
var pageItemTypes = {

    init : function(){
        this.$page = $('.page-item-types');
        
        var self = this;
        
        this.sortable = new Sortable(this.$page.find('.list').get(0), {
            animation: 100,
            handle: 'button[data-move]',
            direction: 'vertical',
            onEnd: function (event) {
                var orders = {ids: [], orders : []};

                self.$page.find('.list .item').each(function(){
                    var $item = $(this);
                    orders.ids.push($item.data('id'));
                    orders.orders.push($item.index() + 1);
                });
                serviceCtrl.updateItemTypesOrder(orders, function(result){
                    mainCtrl.showNotify(result);
                });
            },
        });
        

        var self = this;
        
        this.$page.on('click', 'button[data-delete]', function(){
            var id = parseInt($(this).closest('.item').data('id'));
            
            modalCtrl.deleteItemTypeModal(function(){
                serviceCtrl.deleteItemType(id, function(result){
                    mainCtrl.showNotify(result[0]);
                    self.$page.find('.item-list').replaceWith(result[1]);
                });
            });

        });
        
        pageBase.init.apply(this, arguments); //call super
    }
}


window.pageItemTypes = $.extend(true, {}, pageBase, pageItemTypes); //must be deep copy;
	
}($);