+function ($) {
    "use strict";
    
var pagePermEditBase = {
	


    init : function(){
        this.$inputs = this.$page.find('input[type="checkbox"]');
        
        //functional inputs
        this.$inputsAdminAddDel = 
                this.$inputs.filter('[name="perms[add_delete_item_types]"],[name="perms[add_delete_event_types]"],[name="perms[add_delete_users]"]');
        
        var self = this;
        //clicked on any one of admin add delete property will select automatically edit property 
        this.$inputsAdminAddDel.on('change', function(){
            var $input = $(this);
            var checked = $input.prop('checked');

            $input.closest('.custom-control').prev()
                    .find('input[type="checkbox"]').not('.inherited')
                    .prop('checked', checked)
                    .prop('disabled', checked);
        });
        
        //item desc1 and 2
        this.$inputs.filter('[name^="perms[item_events_desc"]').on('change', function(event){
            var $input = $(this);
            var checked = $input.prop('checked');

            var id = self._getId($input);
            
            self._setInputValues($input,'item_events_browse_id_'+ id, checked);

            if(event.originalEvent)
                self._triggerInputSiblings($input);
            
            if(event.originalEvent)
                self._triggerAllChecked($input);
        });
        
        //item editing events
        this.$inputs.filter('[name^="perms[item_events_edit"]').on('change', function(event){
            var $input = $(this);
            var checked = $input.prop('checked');

            var id = self._getId($input);
            
            self._setInputValues($input, [
                    'item_events_browse_id_'+ id,
                    'item_events_desc1_id_'+ id,
                    'item_events_desc2_id_'+ id
                    ],
                    checked);
                   
            if(event.originalEvent) //prote
                self._triggerAllChecked($input);
        });
        
        
        this.$inputs.filter('[name^="perms[item_type_events_browse"]').on('change', function(event){
            var $input = $(this);
            var checked = $input.prop('checked');

            var id = self._getId($input);
         
            var typeIdAttr = id != 'all' ? '[data-dependent-id="'+ id +'"]' : '';
         
            if (id == 'all'){
                self._setInputValues($input, 'item_type_events_browse', checked);
            }
            
            self._setInputValues($input, 'item_' + self._getPermName($input), checked, true, typeIdAttr);
        });
        
        
        this.$inputs.filter('[name^="perms[item_type_events_desc"]').on('change', function(event){
            var $input = $(this);
            var checked = $input.prop('checked');

            var id = self._getId($input);
            var typeIdAttr = id != 'all' ? '[data-dependent-id="'+ id +'"]' : '';
         
           
            self._setInputValues($input, 'item_' + self._getPermName($input), checked, true, typeIdAttr);
            
            self._setInputValues($input,'item_type_events_browse_id_'+ id, checked);
            
            if (id == 'all'){
                self._setInputValues($input, 'item_type_' + self._getPermName($input), checked, true);
            }

            if(event.originalEvent)
                self._triggerInputSiblings($input);
            

        });
        
        
        this.$inputs.filter('[name^="perms[item_type_events_edit"]').on('change', function(event){
            var $input = $(this);
            var checked = $input.prop('checked');
                
            var id = self._getId($input);
            
            self._setInputValues($input, 
                [
                    'item_type_events_browse_id_'+ id, 
                    'item_type_events_desc1_id_'+ id, 
                    'item_type_events_desc2_id_'+ id
                ],
                checked);
            
            var typeIdAttr = id != 'all' ? '[data-dependent-id="'+ id +'"]' : '';
         
            self._setInputValues($input, 'item_' + self._getPermName($input), checked, true, typeIdAttr);
            
            if (id == 'all'){
                self._setInputValues($input, 'item_type_events_edit', checked, true);
            }
            
            if(event.originalEvent)
                self._triggerAllChecked($input);
            
        });
        
        
        
        this.$inputs.filter('[name^="perms[item_type_edit"]').on('change', function(event){
            var $input = $(this);
            var checked = $input.prop('checked');

            var id = self._getId($input);
            var typeIdAttr = id != 'all' ? '[data-dependent-id="'+ id +'"]' : '';

            self._setInputValues($input, 'item_' + self._getPermName($input), checked, true, typeIdAttr);
    
            if (id == 'all'){
                self._setInputValues($input, 'item_type_edit', checked, true);
            }
        });
        
        
        this.$inputs.filter('[name^="perms[item_type_add_delete"]').on('change', function(event){
            var $input = $(this);
            var checked = $input.prop('checked');

            var id = self._getId($input);
            var typeIdAttr = id != 'all' ? '[data-dependent-id="'+ id +'"]' : '';

            self._setInputValues($input, 'item_edit', checked, true, typeIdAttr);
            
            self._setInputValues($input,'item_type_edit_id_'+ id, checked);
    
            if (id == 'all'){
                self._setInputValues($input, 'item_type_add_delete', checked, true);
            }
        });
        

        pageFormBase.init.apply(this, arguments); //call super
        pageBase.init.apply(this, arguments); //call super
    },
    
    
    _triggerInputSiblings : function($input){
        $input.closest('.form-group').find('input[type="checkbox"]:checked')
            .not($input)
            .trigger('change');
    },
    
    _setInputValues : function($input, permBeginsWith, checked, trigger, additionalSelector){
        
        var s = [];
        if ($.isArray(permBeginsWith)){
            var a = [];
            permBeginsWith.forEach(function(value){
                a.push('[name^="perms['+ value +'"]');
            });
            s = a.join(',');
        }
        else{
            s = '[name^="perms['+ permBeginsWith +'"]';
        }
        
        s = s + (additionalSelector ? additionalSelector : '');

        var $f = this.$inputs.filter(s).not('.inherited').not($input);
        
        $f.prop('checked', checked).prop('disabled', checked);
    
        if (trigger)
            $f.trigger('change');
    },
    
    _triggerAllChecked: function($input){
        this.$inputs.filter(':checked')
            .not($input)
            .trigger('change');
    },

    _getPermName: function($input){
        var name = $input.attr('name');
        
        //find perm name for item
        var itemPermName = name.replace('item_type_', '').replace('perms[', '').replace(']', '');    
        itemPermName = itemPermName.substr(0,itemPermName.lastIndexOf('_')+1);

        return itemPermName;
    },
    
    
    _getId: function($input){
        var name = $input.attr('name');
        return name.substr(name.lastIndexOf('_')+1).replace(']', '');
    },

    
    //this is called twice on start and after saving
    fillForm : function(){
        pageFormBase.fillForm.apply(this, arguments); //call super

        var self = this;
        this.formData.perms.forEach(function(permName){
            self.$inputs.filter('[name="perms['+ permName +']"]').prop('checked', true).trigger('change');
        });
        
        formValidator.cleanFormDirty(this.$form);
    },
    
    serializeForm : function(){
        var serialized = pageFormBase.serializeForm.apply(this, arguments); //call super

        var self = this;
        
        var newPerms = [];
        //send all not disabled only disabled fields values to 0, we only uses it for visual help
        $.each(serialized.perms, function( permName, value ) {
            if (value && !self.$inputs.filter('[name="perms['+ permName +']"]').prop('disabled'))
                newPerms.push(permName);
        });
        
        serialized.perms = newPerms;

        return serialized;
    }

};
	
window.pagePermEditBase = $.extend(true, {}, pageBase, pageFormBase, pagePermEditBase); //must be deep copy;
	
}($);