+function ($) {
    "use strict";
    
var pagePermUserEdit = {
	
    init : function(){
        this.$page = $('.page-perm-user-edit');
        
        this.serviceMethod = 'saveUserPerms';
        this.formData = YourCalendar.user_perms;
        
        var self = this;
        
        
        
        //we want to attach this before iitnitaiall form fill, so we do not have $inputs, search on page 
        this.$page.find('input[name^="groups"]').change(function(event){
            
            var $input = $(this);
            var groupId = parseInt($input.val());
            var checked = $input.prop('checked');
            
            if (!event.originalEvent && !checked) //not triggered by click and value is not checked
                return;

            var groupObj;
            $.each(YourCalendar.groups, function( index, group ) {
                if (group.id == groupId){
                    groupObj = group;
                    return false;//break loop
                }
            });
            
            if (groupId == 1 ){ //admin trigger only when clicked not when triggered by code
                self.$inputs
                        .filter('[name^="perms["]')
                        .prop('checked', checked)
                        .prop('disabled', checked)
                        .trigger('change')
                        .toggleClass('inherited', checked)
                        .siblings('label').toggleClass('inherited', checked);
            }
            else{
                //select or deselect that this group contains
                $.each(groupObj.perms, function( index, perm ) {
                    self.$inputs
                            .filter('[name="perms['+perm+']"]')
                            .prop('checked', checked)
                            .prop('disabled', checked)
                            .trigger('change')
                            .toggleClass('inherited', checked)
                            .siblings('label').toggleClass('inherited', checked);
                });
            }

            //collect permissions from all other selected groups
            var perms = [];
            var hasAdmin = false;
            self.$inputs.filter('[name^="groups"]:checked').not($input).each(function(){
                var $input = $(this);
                var groupId = parseInt($input.val());
                
                if (groupId == 1){
                    hasAdmin = true;
                    return;
                }

                var groupObj;
                $.each(YourCalendar.groups, function( index, group ) {
                    if (group.id == groupId){
                        groupObj = group;
                        return false;//break loop
                    }
                });

                perms = perms.concat(groupObj.perms);
            });
            
            //make only unique values
            perms = perms.filter(function(itm, i, a) {
                return i == a.indexOf(itm);
            });

//            console.log(groupId);
            if (hasAdmin == 1){ //admin
                self.$inputs
                        .filter('[name^="perms["]')
                        .prop('checked', true)
                        .prop('disabled', true)
                        .trigger('change')
                        .toggleClass('inherited', checked)
                        .siblings('label').toggleClass('inherited', true);
            }
            else{
                $.each(perms, function( index, perm ) {
                    self.$inputs
                            .filter('[name="perms['+perm+']"]')
                            .prop('checked', true)
                            .prop('disabled', true)
                            .trigger('change')
                            .toggleClass('inherited', checked)
                            .siblings('label').toggleClass('inherited', true);
                });
            }

            //will find only permissions set not by groups, re trigger its handler to properly fill whats unselected when unselecting group
            $.each(self.serializeForm().perms, function( index, perm ) {
//                console.log(perm,1);
                self.$inputs.filter('[name="perms['+perm+']"]').trigger('change');
            });
        });
        
        pagePermEditBase.init.apply(this, arguments); //call super
    },
    
    
    fillForm : function(){
        pagePermEditBase.fillForm.apply(this, arguments); //call super

        var self = this;
        //check groups attached to user
        this.formData.groups.forEach(function(group){
            self.$inputs.filter('[name="groups[]"][value="'+ group.id +'"]').prop('checked', true);
        });
        
        this.$inputs.filter('[name^="groups"]').trigger('change');

        formValidator.cleanFormDirty(this.$form);
    },
    
    serializeForm : function(){
        var serialized = pagePermEditBase.serializeForm.apply(this, arguments); //call super

        var self = this;
        var groups = [];
        
        //send all not disabled only disabled fields values to 0, we only uses it for visual help
        this.$inputs.filter('[name^="groups"]').each(function(){
            var groupId = parseInt($(this).val()),
                checked = $(this).prop('checked');
                
//                console.log(1);
            if (checked){
                groups.push({id: groupId});
            }
            
        });
        serialized.groups = groups ;
        
        return serialized;
    }
};
	
window.pagePermUserEdit = $.extend(true, {}, pagePermEditBase, pagePermUserEdit); //must be deep copy;
	
}($);