+function ($) {
    "use strict";
    
var pageUserEdit = {
	
    init : function(){
        this.$page = $('.page-user-edit');
        this.$passInput = this.$page.find('input[name="password"]');
        
        pageBase.init.apply(this, arguments); //call super
                
        this.serviceMethod = 'saveUser';
        this.formData = YourCalendar.user;
        
        
        var self = this;
        
        this.$page.find('input[name="pass_change"]').change(function(){
            var val = $(this).prop('checked');
            
//            console.log(val);
            self.$passInput
                    .toggleClass('val-ignored', !val)
                    [val ? 'removeAttr' : 'attr']('disabled', 'disabled');
                    
            formValidator.unhighlightField(self.$passInput);
                    
        });
        
        
        pageFormBase.init.apply(this, arguments); //call super
    },
    
    //this is called twice on start and after saving
    fillForm : function(){

        var $passChange =  this.$page.find('input[name="pass_change"]');
    
        //editing user
        if ( this.formData.id != 0){
            $passChange.prop('checked', false);
            this.$passInput.val('');
            $passChange.trigger('change');
        }
        
        pageFormBase.fillForm.apply(this, arguments); //call super
    },
    
    //override
    saveSuccessCallback : function(message, data){
        if (data === 'user_exists'){
            formValidator.highlightForm(this.$form);
            formValidator.highlightField(this.$page.find('input[name="username"]'), message);
            return;
        }
        

        YourCalendar.user = data;

        pageFormBase.saveSuccessCallback.apply(this, arguments); //call super
    },
    
    serializeForm : function(){
        var serialized = pageFormBase.serializeForm.apply(this, arguments); //call super
        
        //check are we saving new user or 
        if (serialized.id == '0'){        
            this.savingNewUser = true;
        }
        
        return serialized;
    }
        

};
	
window.pageUserEdit = $.extend(true, {}, pageBase, pageFormBase, pageUserEdit); //must be deep copy;
	
}($);