+function ($) {
    'use strict';

    var MonthSelector = function (element, options) {
        this.$element = null;
		
        this.options = null;

        this.init(element, options);
    };

    MonthSelector.prototype.init = function (element, options) {
        this.$element = $(element);
        this.options = this.getOptions(options);
		
        var self = this;

        this.$element.popover({
            trigger: 'click',
            html: true,
            sanitize: false,
            content: function(el){
                    // console.log();
                    return $('#monthSelector').get(0).outerHTML;
            },	
            placement: 'bottom',
            template: '<div class="popover months-popover" role="tooltip"><div class="arrow"></div><div class="popover-body"></div></div>',
        })
        .on('shown.bs.popover', function (e) {
            var $opener = $(e.target);
            var bsData = $opener.data()['bs.popover'];
            var $popover = $(bsData.tip);


            $popover.on('click', 'button', function(){
                var $button = $(this);
                var $year = $button.siblings('.year'),
                        offset = $button.is('[data-next]') ? 1 : -1;

                $button.siblings('.year').text(parseInt($year.text()) + offset);
            });	

            $popover.on('click', 'a.dropdown-item', function(event){
                event.preventDefault();
                $opener.popover('hide');
                
                var year =  parseInt($popover.find('.year').text());
                var month =  parseInt($(this).data('num'));
                
                $('#monthSelector').data('month', month);
                
                self._updateSelection();
                
                self.$element.triggerHandler('change', {year: year, month: month});
                

//                alert($(this).data('num') + ' ' + parseInt($popover.find('.year').text()));
            });

            mainCtrl.$body.on('click.monthPopover', function(event){
                var $target = $(event.target);

                // console.log($target, $target.closest('.months-popover').length);
                if (!$target.closest('.months-popover').length && !$target.is('.months-popover') ){
                    var $opener = $($('.months-popover').data('bs.popover').element);
                    $opener.popover('hide');
                }
            });

        })	
        .on('hidden.bs.popover', function (e) {
            var $opener = $(e.target);
            var bsData = $opener.data()['bs.popover'];
            var $popover = $(bsData.tip);

            $popover.off('click');

            mainCtrl.$body.off('click.monthPopover');
        });

        this._updateSelection();
    };


    MonthSelector.prototype.getOptions = function (options) {
        var defaults = {

        };

        //faster than jquery EXTEND
        for (var key in options) {
            defaults[key] = options[key];
        }

        return defaults;
    };

    MonthSelector.prototype._updateSelection = function () {
        $('#monthSelector').find('.dropdown-item').removeClass('active').eq(parseInt($('#monthSelector').data('month')) - 1).addClass('active');
    };
    
    MonthSelector.prototype.destroy = function () {
        mainCtrl.$body.off('.monthPopover');
    };


    $.fn.monthSelector = function (option, param) {
        var $this = $(this).first(); //this plugin only gets first elment
        var data = $this.data('flexphperia.MonthSelector');
        var options = typeof option == 'object' && option;

        if (!data && /destroy/.test(option))
            return; //destroy call return
        if (!data)
            $this.data('flexphperia.MonthSelector', (data = new MonthSelector(this, options))); // constructor call

        if (typeof option == 'string') {
            return data[option](param);
        } //if method call

        return this;
    };

    $.fn.monthSelector.Constructor = MonthSelector;

}(jQuery);